package com.jasamedika.medifirst2000.controller;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.jasamedika.medifirst2000.constants.Constants;
import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.core.web.WebConstants;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.EvaluasiRekananService;
import com.jasamedika.medifirst2000.util.rest.RestUtil;
import com.jasamedika.medifirst2000.vo.UsulanEvaluasiVO;

/**
 * class Usulan Evaluasi Controller
 * 
 * @author Lukman Hakim
 */
@RestController
@RequestMapping("/penanganan-kasus")
public class PenangananKasusController extends LocaleController<UsulanEvaluasiVO>{
	private static final Logger LOGGER = LoggerFactory.getLogger(PenangananKasusController.class);
	
	@Autowired
	private EvaluasiRekananService evaluasiRekananService;
	
	@RequestMapping( value = "/save", method = RequestMethod.POST,  produces = MediaType.APPLICATION_JSON_VALUE, consumes = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<String> saveEvaluasiRekanan(
			 @RequestBody UsulanEvaluasiVO vo, HttpServletRequest request) {
		
		try {
			String result = evaluasiRekananService.saveEvaluasiRekanan(vo);
			
			if (result != null)
				mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,
						getMessage(MessageResource.LABEL_SUCCESS, request));
			return RestUtil.getJsonResponse(result, HttpStatus.CREATED, mapHeaderMessage);
		} catch (ServiceVOException e) {

			LOGGER.error("Got exception {} when savePlanningDHM", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR, mapHeaderMessage);

		} catch (JpaSystemException jse) {

			LOGGER.error("Got exception {} when savePlanningDHM", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT, mapHeaderMessage);
		} 
	}
	@RequestMapping(value = "/get-no-evaluasi", method = RequestMethod.GET)
	public ResponseEntity<Map<String,Object>> getNoEvaluasi(HttpServletRequest request) {
		
		try {
			String noSurat= evaluasiRekananService.noEvaluasiRekanan();
			Map<String,Object> result=new HashMap<String,Object>();
			result.put("noSurat", noSurat);
			if (null != result)
			mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,getMessage(MessageResource.LABEL_SUCCESS,request ));
			return RestUtil.getJsonResponse(result, HttpStatus.OK,mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when add nota-dinas", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE,
					e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR,
					mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when add nota-dinas", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE,
					jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT,
					mapHeaderMessage);
		}
	}
	 
	@RequestMapping(value = "/get-list-evaluasi-by-ruangan-tujuan", method = RequestMethod.GET)
	public ResponseEntity<List<Map<String,Object>>> getListUsulanEvaluasiByRuanganTujuan(
			@RequestParam(value = "noUsulan", required = false) String noUsulan,
			@RequestParam(value = "tglAwal", required = true)String tglAwal, 
			@RequestParam(value = "tglAkhir", required = true)String tglAkhir, 
			@RequestParam(value = "ruanganId", required = true)Integer ruanganId,
			HttpServletRequest request) {
		
		try {
			List<Map<String,Object>> noSurat= evaluasiRekananService.listUsulanEvaluasiByRuanganTujuan(tglAwal, tglAkhir,noUsulan,ruanganId);
			 
			 
			mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,getMessage(MessageResource.LABEL_SUCCESS,request ));
			return RestUtil.getJsonResponse(noSurat, HttpStatus.OK,mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when add nota-dinas", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE,
					e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR,
					mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when add nota-dinas", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE,
					jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT,
					mapHeaderMessage);
		}
	}
	@RequestMapping(value = "/get-list-evaluasi-by-ruangan-pembuat", method = RequestMethod.GET)
	public ResponseEntity<List<Map<String,Object>>> getListUsulanEvaluasiByRuanganPembuat(
			@RequestParam(value = "noUsulan", required = false) String noUsulan,
			@RequestParam(value = "tglAwal", required = true)String tglAwal, 
			@RequestParam(value = "tglAkhir", required = true)String tglAkhir, 
			@RequestParam(value = "ruanganId", required = true)Integer ruanganId,
			HttpServletRequest request) {
		
		try {
			List<Map<String,Object>> noSurat= evaluasiRekananService.listUsulanEvaluasiByRuanganPembuat(tglAwal, tglAkhir, noUsulan, ruanganId);
			 
			 
			mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,getMessage(MessageResource.LABEL_SUCCESS,request ));
			return RestUtil.getJsonResponse(noSurat, HttpStatus.OK,mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when add nota-dinas", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE,
					e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR,
					mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when add nota-dinas", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE,
					jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT,
					mapHeaderMessage);
		}
	}
	@RequestMapping(value = "/get-by-nousulan/", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String,Object>> getUsulanEvaluasiByNoUsulan(
			@RequestParam(value = "noUsulan", required = true) String noUsulan) {
		Map<String,Object> resultPageMap = evaluasiRekananService.usulanEvaluasiByNoUsulan(noUsulan);
		 
		return RestUtil.getJsonResponse(resultPageMap, HttpStatus.OK, mapHeaderMessage);
	}
	@RequestMapping( value = "/save-rekomendasi", method = RequestMethod.POST,  produces = MediaType.APPLICATION_JSON_VALUE, consumes = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String,Object>> saveRekomendasi(
			 @RequestBody UsulanEvaluasiVO vo, HttpServletRequest request) {
		
		try {
			Map<String,Object> result = evaluasiRekananService.saveRekomendasiEvaluasiRekanan(vo);
			
			if (result != null)
				mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,
						getMessage(MessageResource.LABEL_SUCCESS, request));
			return RestUtil.getJsonResponse(result, HttpStatus.CREATED, mapHeaderMessage);
		} catch (ServiceVOException e) {

			LOGGER.error("Got exception {} when savePlanningDHM", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR, mapHeaderMessage);

		} catch (JpaSystemException jse) {

			LOGGER.error("Got exception {} when savePlanningDHM", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT, mapHeaderMessage);
		} 
	}
}
